-- GoHv5_wait(2.5, GoHv5_printMSG,"Test");

local waitTable = {};
local waitFrame = nil;

function GoHv5_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

function GoHv5_printMSG(msg)
    -- DEFAULT_CHAT_FRAME:AddMessage("Prefix " .. msg .. " Suffix", 1, 1, 1);
    print(msg);
end


	-- SECONDARY TIMER SET UP (TO REDUCE SPAM)
	local GoHv5_Secondary_Timer = {}
	_G.GoHv5_Secondary_Timer = GoHv5_Secondary_Timer
	local frame = _G.GoHv5_Secondary_Timer_Frame
	local GoH_Secondary_Timer_Time = 0;
	local GoH_Secondary_Timer_Ticks_at = 102; --time to get to
	local GoH_Secondary_elapsedTime = 1

function GoHv5_Secondary_Timer:OnUpdate(GoH_Secondary_elapsedTime)

	if (GoHv5_DeathKnight_Data.config.DEBUG_HIDE_BLIZZARD_LUA_ERRORS == "YES") then
		-- HIDE THAT FUCKING BULLSHIT SCRIPT TOO LONG CRAP!
		if (ScriptErrorsFrame ~= nil) then
		if (ScriptErrorsFrame:IsVisible()) then
			ScriptErrorsFrame:Hide();
			print("|cFFFF0000GoH:|r |cFFFFD000Automatically hide a|r |cFFFFFFFF'script too long'|r |cFFFFD000error.|r");
			print("|cFFAAAAAAThis was done so that the message did not remain on your screen and but you whilst you were in combat. Unfortunately, this error is Blizzards fault and not the fault of any other addon.|r");
			print("|cFFFFFFFFIf you do not want these hidden, open GoH Settings Menu, click the Spanner Icon and untick Hide Lua Errors.|r");
			return;
		end
		end
	end


	if InCombatLockdown() then
		-- IF IN COMBAT DO THIS
	else
		-- IF NOT IN COMBAT DO THAT

		-- FORCING THIS OFF INSTEAD OF REMOVING ALL THE CODE. IT'S BUGGY.
		GoHv5_DeathKnight_Data.config.Fade_Menu_In_and_Out = "NO";
		GoH_SETTINGS_USE_FADE_MENUS_OPTION:Disable();
		GoH_SETTINGS_USE_FADE_MENUS_OPTION:Hide();
		Settings_Fade_Menus_Text:Hide();

		doIsVisible_Check();

			-- print("timer 2 working")

						-- GOH SETTING: GENDER BENDER
						if GoHv5_DeathKnight_Data.config.Gender_Bender == nil then
							GoHv5_DeathKnight_Data.config.Gender_Bender = "NO";
						end

						if GoH_DeathKnight.RealGender == nil then
							GoH_DeathKnight.RealGender = genderTable[UnitSex("player")];
						end
						if GoH_DeathKnight.Gender == nil then
							GoH_DeathKnight.Gender = GoH_DeathKnight.RealGender;
						end

			-- GOH SETTING: GENDER BENDER
			if GoHv5_DeathKnight_Data.config.Gender_Bender == "NO" then
				-- REAL GENDER
				GoH_DeathKnight.Gender = GoH_DeathKnight.RealGender;
			else
				-- OPPOSITE TO REAL
				if GoH_DeathKnight.RealGender == "Female" then
					-- Change to Male
					GoH_DeathKnight.Gender = "Male";
				else
					-- Change to Female
					GoH_DeathKnight.Gender = "Female";
				end
			end
			if GoH_DeathKnight.Gender == "Female" then
				Settings_Female_Texture:Show();
			else
				Settings_Female_Texture:Hide();
			end

			-- print("Real Gender: "..GoH_DeathKnight.RealGender);
			-- print("Preferred Gender: "..GoH_DeathKnight.Gender);
	end


				-- GOH SECONDARY TIMER
	  			if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == nil then
					GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "YES";
				end
				-- GOH SECONDARY TIMER
	  			if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time == nil then
					GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
				end

	if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "NO" then

		-- If I use GoH_elapsedTime in the next line instead of 1,
		-- WoW decides to be a bitch. So I just use 1.
        GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time + 1;
        -- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Time);
        if(GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time >= 102) then
            --Your timer just dinged, now do whatever you want.
            GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "YES";
            GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
        end

	end

end


	-- TIMER SET UP (TO REDUCE SPAM)
	local GoHv5_Timer = {}
	_G.GoHv5_Timer = GoHv5_Timer
	local frame = _G.GoHv5_Timer_Frame
	local GoH_Timer_Time = 0;
	local GoH_Timer_Ticks_at = 102; --time to get to
	local GoH_elapsedTime = 1

function do_VS_HUD()

	if InCombatLockdown() then
		-- IF IN COMBAT DO THIS
	else
		-- IF NOT IN COMBAT DO THAT

			GoH4_Player:SetScale(GoHv5_DeathKnight_Data.config.GoHv5_SliderSetter);
			GoH4_Target:SetScale(GoHv5_DeathKnight_Data.config.GoHv5_SliderSetter);
			GoH4_VS:SetScale(GoHv5_DeathKnight_Data.config.GoHv5_SliderSetter);

			if (GoH_Frame_Page2:IsVisible()) then
				-- FRAME VISIBLE SO YOU CAN MOVE THE HUD

					if GoHv5_DeathKnight_Data.config.Use_HUD_VS == "YES" then
						GoH4_VS:EnableMouse(true)
					else
						GoH4_VS:EnableMouse(false)
					end
					if GoHv5_DeathKnight_Data.config.Use_HUD_Target == "YES" then
						GoH4_Target:EnableMouse(true)
					else
						GoH4_Target:EnableMouse(false)
					end
					if GoHv5_DeathKnight_Data.config.Use_HUD_Player == "YES" then
						GoH4_Player:EnableMouse(true)
					else
						GoH4_Player:EnableMouse(true)
					end

			else
				-- FRAME NOT VISIBLE SO YOU CANNNOT MOVE THE HUD

					GoH4_VS:EnableMouse(false)
					GoH4_Target:EnableMouse(false)
					GoH4_Player:EnableMouse(false)

			end
	end

	if GoHv5_DeathKnight_Data.config.Use_VS_HUD == "YES" then
		-- YOU CAN SEE THE HUD BECAUSE YOU ARE USING THE HUD

		if (GoHv5_DeathKnight_Data.config.Use_VS_HUD_COMBAT_ONLY == "YES") then
			-- YOU ONLY WANT TO SEE THE HUD DURING COMBAT...

			if (GoHv5_DeathKnight_Data.config.Unit_In_Combat == "YES") then
				-- WELL YOU'RE IN COMBAT, YIPPY

				if GoHv5_DeathKnight_Data.config.Use_HUD_VS == "YES" then
					GoH4_VS:Show();
				else
					GoH4_VS:Hide();
					GoH4_VS:EnableMouse(false)
				end
				if GoHv5_DeathKnight_Data.config.Use_HUD_Target == "YES" then
					GoH4_Target:Show();
				else
					GoH4_Target:Hide();
					GoH4_Target:EnableMouse(false)
				end
				if GoHv5_DeathKnight_Data.config.Use_HUD_Player == "YES" then
					GoH4_Player:Show();
				else
					GoH4_Player:Hide();
					GoH4_Player:EnableMouse(false)
				end

			else
				-- YOU ARE NOT IN COMBAT, HIDE THE HUD... UNLESS YOU HAVE GoH Settings Page 2 Open...

				if (GoH_Frame_Page2:IsVisible()) then
					-- FRAME VISIBLE SO YOU CAN MOVE THE HUD

						GoH4_VS:EnableMouse(true)
						GoH4_Target:EnableMouse(true)
						GoH4_Player:EnableMouse(true)

						if GoHv5_DeathKnight_Data.config.Use_HUD_VS == "YES" then
							GoH4_VS:Show();
						else
							GoH4_VS:Hide();
							GoH4_VS:EnableMouse(false)
						end
						if GoHv5_DeathKnight_Data.config.Use_HUD_Target == "YES" then
							GoH4_Target:Show();
						else
							GoH4_Target:Hide();
							GoH4_Target:EnableMouse(false)
						end
						if GoHv5_DeathKnight_Data.config.Use_HUD_Player == "YES" then
							GoH4_Player:Show();
						else
							GoH4_Player:Hide();
							GoH4_Player:EnableMouse(false)
						end

				else
					-- FRAME NOT VISIBLE SO YOU CANNNOT MOVE THE HUD

						GoH4_VS:EnableMouse(false)
						GoH4_Target:EnableMouse(false)
						GoH4_Player:EnableMouse(false)

						GoH4_VS:Hide();
						GoH4_Target:Hide();
						GoH4_Player:Hide();

				end

			end

		else
			-- YOU WANT TO SEE THE HUD ALL THE TIME... SO BE IT.

				if GoHv5_DeathKnight_Data.config.Use_HUD_VS == "YES" then
					GoH4_VS:Show();
				else
					GoH4_VS:Hide();
					GoH4_VS:EnableMouse(false)
				end
				if GoHv5_DeathKnight_Data.config.Use_HUD_Target == "YES" then
					GoH4_Target:Show();
				else
					GoH4_Target:Hide();
					GoH4_Target:EnableMouse(false)
				end
				if GoHv5_DeathKnight_Data.config.Use_HUD_Player == "YES" then
					GoH4_Player:Show();
				else
					GoH4_Player:Hide();
					GoH4_Player:EnableMouse(false)
				end

		end

	else
		-- YOU CANNOT SEE THE HUD BECAUSE YOU ARE NOT USING THE HUD

			GoH4_VS:Hide();
			GoH4_Target:Hide();
			GoH4_Player:Hide();

	end


end

function GoHv5_Timer:OnUpdate(GoH_elapsedTime)

	if InCombatLockdown() then
		-- IF IN COMBAT DO THIS
	else
		-- IF NOT IN COMBAT DO THAT

		GoH5_DeathKnight_SavedVariables();
	end

	do_VS_HUD();

	-- print("timer 1 working")

	if (GoH_DeathKnight.Class == "DEATHKNIGHT") then
		doBloodPresenceReminder();
		GoHv5_doDeathKnight_PlayerFrames();
		GoHv5_doDeathKnight_EndCaps();
		do_HornOfWinter_Reminder();
	end


	if (GoH_DeathKnight.Class == "MONK") then
		-- CHECK TO SEE IF GoH_Monk IS INSTALLED
		_, _, _, GoH_Monk_enabled, _, _, _ = GetAddOnInfo("GoH_Monk")
		if GoH_Monk_enabled == 1 then
			-- IF GoH_Paladin IS INSTALLED
			GoHv5_doMonk_PlayerFrames();
			doGotOxReminder();
		end
	end

	if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "NO" then

		-- If I use GoH_elapsedTime in the next line instead of 1,
		-- WoW decides to be a bitch. So I just use 1.
        GoHv5_DeathKnight_Data.config.GoH_Timer_Time = GoHv5_DeathKnight_Data.config.GoH_Timer_Time + 1;
        -- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Time);
        if(GoHv5_DeathKnight_Data.config.GoH_Timer_Time >= 102) then
            --Your timer just dinged, now do whatever you want.
            GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "YES";
            GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
        end

	end

	if (UnitExists("target")) and (UnitIsPlayer("target")) then
		GoHv5_DeathKnight_Data.config.Target_Level_Temp_Value = UnitLevel("target");
		-- print(GoHv5_DeathKnight_Data.config.Target_Level_Temp_Value);
	end

	if InCombatLockdown() then
		-- IF IN COMBAT DO THIS
	else
		-- IF NOT IN COMBAT DO THAT

		doSavedVariable_Plugin_Check();
		doAutoDeclineCheck();
		GoH_Spec();
	end

	if (GoH_DeathKnight.Class == "PALADIN") then
		-- CHECK TO SEE IF GoH_Paladin IS INSTALLED
		_, _, _, GoH_Paladin_enabled, _, _, _ = GetAddOnInfo("GoH_Paladin")
		if GoH_Paladin_enabled == 1 then
			-- IF GoH_Paladin IS INSTALLED
			-- DO RIGHTEOUS FURY REMINDER
			doRighteousFuryReminder();
		end
	end

end

function doSavedVariable_Plugin_Check()

			-- CHECK TO SEE IF GoH_Druid IS INSTALLED
			_, _, _, GoH_Druid_enabled, _, _, _ = GetAddOnInfo("GoH_Druid")
			if GoH_Druid_enabled == 1 then
				-- IF GoH_Druid IS INSTALLED
				GoH_Druid_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Hunter IS INSTALLED
			_, _, _, GoH_Hunter_enabled, _, _, _ = GetAddOnInfo("GoH_Hunter")
			if GoH_Hunter_enabled == 1 then
				-- IF GoH_Hunter IS INSTALLED
				GoH_Hunter_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Mage IS INSTALLED
			_, _, _, GoH_Mage_enabled, _, _, _ = GetAddOnInfo("GoH_Mage")
			if GoH_Mage_enabled == 1 then
				-- IF GoH_Mage IS INSTALLED
				GoH_Mage_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Monk IS INSTALLED
			_, _, _, GoH_Monk_enabled, _, _, _ = GetAddOnInfo("GoH_Monk")
			if GoH_Monk_enabled == 1 then
				-- IF GoH_Monk IS INSTALLED
				GoH_Monk_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Paladin IS INSTALLED
			_, _, _, GoH_Paladin_enabled, _, _, _ = GetAddOnInfo("GoH_Paladin")
			if GoH_Paladin_enabled == 1 then
				-- IF GoH_Paladin IS INSTALLED
				GoH_Paladin_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Priest IS INSTALLED
			_, _, _, GoH_Priest_enabled, _, _, _ = GetAddOnInfo("GoH_Priest")
			if GoH_Priest_enabled == 1 then
				-- IF GoH_Priest IS INSTALLED
				GoH_Priest_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Rogue IS INSTALLED
			_, _, _, GoH_Rogue_enabled, _, _, _ = GetAddOnInfo("GoH_Rogue")
			if GoH_Rogue_enabled == 1 then
				-- IF GoH_Rogue IS INSTALLED
				GoH_Rogue_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Shaman IS INSTALLED
			_, _, _, GoH_Shaman_enabled, _, _, _ = GetAddOnInfo("GoH_Shaman")
			if GoH_Shaman_enabled == 1 then
				-- IF GoH_Shaman IS INSTALLED
				GoH_Shaman_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Warlock IS INSTALLED
			_, _, _, GoH_Warlock_enabled, _, _, _ = GetAddOnInfo("GoH_Warlock")
			if GoH_Warlock_enabled == 1 then
				-- IF GoH_Warlock IS INSTALLED
				GoH_Warlock_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Warrior IS INSTALLED
			_, _, _, GoH_Warrior_enabled, _, _, _ = GetAddOnInfo("GoH_Warrior")
			if GoH_Warrior_enabled == 1 then
				-- IF GoH_Warrior IS INSTALLED
				GoH_Warrior_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Mounts IS INSTALLED
			_, _, _, GoH_Mounts_enabled, _, _, _ = GetAddOnInfo("GoH_Mounts")
			if GoH_Mounts_enabled == 1 then
				-- IF GoH_Mounts IS INSTALLED
				GoH_Mounts_SavedVariables();
			end

			-- CHECK TO SEE IF GoH_Pokemon IS INSTALLED
			_, _, _, GoH_Pokemon_enabled, _, _, _ = GetAddOnInfo("GoH_Pokemon")
			if GoH_Pokemon_enabled == 1 then
			-- IF GoH_Pokemon IS INSTALLED
				GoH_Pokemon_SavedVariables();
			end

end


function doIsVisible_Check()

	if InCombatLockdown() then
		-- IF IN COMBAT DO THIS
	else
		-- IF NOT IN COMBAT DO THAT

			GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " ALL"

			GoHv5_DeathKnight_Data.config.Menu_IsVisible = "NO";

			if (GoH_Form:IsVisible()) then
				GoH_Form:Show();
				GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
				GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " SETTINGS";
			else
				GoH_Form:Hide();
			end

			if (GoH_DeathKnight_Form:IsVisible()) then
				GoH_DeathKnight_Form:Show();
				GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
				GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " DEATHKNIGHT";
			else
				GoH_DeathKnight_Form:Hide();
			end


					-- CHECK TO SEE IF GoH_Druid IS INSTALLED
					_, _, _, GoH_Druid_enabled, _, _, _ = GetAddOnInfo("GoH_Druid")
					if GoH_Druid_enabled == 1 then
						-- IF GoH_Druid IS INSTALLED
						if (GoH_Druid_Form:IsVisible()) then
							GoH_Druid_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " DRUID";
						else
							GoH_Druid_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Hunter IS INSTALLED
					_, _, _, GoH_Hunter_enabled, _, _, _ = GetAddOnInfo("GoH_Hunter")
					if GoH_Hunter_enabled == 1 then
						-- IF GoH_Hunter IS INSTALLED
						if (GoH_Hunter_Form:IsVisible()) then
							GoH_Hunter_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " HUNTER";
						else
							GoH_Hunter_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Mage IS INSTALLED
					_, _, _, GoH_Mage_enabled, _, _, _ = GetAddOnInfo("GoH_Mage")
					if GoH_Mage_enabled == 1 then
						-- IF GoH_Mage IS INSTALLED
						if (GoH_Mage_Form:IsVisible()) then
							GoH_Mage_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " MAGE";
						else
							GoH_Mage_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Monk IS INSTALLED
					_, _, _, GoH_Monk_enabled, _, _, _ = GetAddOnInfo("GoH_Monk")
					if GoH_Monk_enabled == 1 then
						-- IF GoH_Monk IS INSTALLED
						if (GoH_Monk_Form:IsVisible()) then
							GoH_Monk_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " MONK";
						else
							GoH_Monk_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Paladin IS INSTALLED
					_, _, _, GoH_Paladin_enabled, _, _, _ = GetAddOnInfo("GoH_Paladin")
					if GoH_Paladin_enabled == 1 then
						-- IF GoH_Paladin IS INSTALLED
						if (GoH_Paladin_Form:IsVisible()) then
							GoH_Paladin_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " PALADIN";
						else
							GoH_Paladin_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Priest IS INSTALLED
					_, _, _, GoH_Priest_enabled, _, _, _ = GetAddOnInfo("GoH_Priest")
					if GoH_Priest_enabled == 1 then
						-- IF GoH_Priest IS INSTALLED
						if (GoH_Priest_Form:IsVisible()) then
							GoH_Priest_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " PRIEST";
						else
							GoH_Priest_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Rogue IS INSTALLED
					_, _, _, GoH_Rogue_enabled, _, _, _ = GetAddOnInfo("GoH_Rogue")
					if GoH_Rogue_enabled == 1 then
						-- IF GoH_Rogue IS INSTALLED
						if (GoH_Rogue_Form:IsVisible()) then
							GoH_Rogue_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " ROGUE";
						else
							GoH_Rogue_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Shaman IS INSTALLED
					_, _, _, GoH_Shaman_enabled, _, _, _ = GetAddOnInfo("GoH_Shaman")
					if GoH_Shaman_enabled == 1 then
						-- IF GoH_Shaman IS INSTALLED
						if (GoH_Shaman_Form:IsVisible()) then
							GoH_Shaman_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " SHAMAN";
						else
							GoH_Shaman_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Warlock IS INSTALLED
					_, _, _, GoH_Warlock_enabled, _, _, _ = GetAddOnInfo("GoH_Warlock")
					if GoH_Warlock_enabled == 1 then
						-- IF GoH_Warlock IS INSTALLED
						if (GoH_Warlock_Form:IsVisible()) then
							GoH_Warlock_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " WARLOCK";
						else
							GoH_Warlock_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Warrior IS INSTALLED
					_, _, _, GoH_Warrior_enabled, _, _, _ = GetAddOnInfo("GoH_Warrior")
					if GoH_Warrior_enabled == 1 then
						-- IF GoH_Warrior IS INSTALLED
						if (GoH_Warrior_Form:IsVisible()) then
							GoH_Warrior_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " WARRIOR";
						else
							GoH_Warrior_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Mounts IS INSTALLED
					_, _, _, GoH_Mounts_enabled, _, _, _ = GetAddOnInfo("GoH_Mounts")
					if GoH_Mounts_enabled == 1 then
						-- IF GoH_Mounts IS INSTALLED
						if (GoH_Mounts_Form:IsVisible()) then
							GoH_Mounts_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " MOUNTS";
						else
							GoH_Mounts_Form:Hide();
						end
					end

					-- CHECK TO SEE IF GoH_Pokemon IS INSTALLED
					_, _, _, GoH_Pokemon_enabled, _, _, _ = GetAddOnInfo("GoH_Pokemon")
					if GoH_Pokemon_enabled == 1 then
					-- IF GoH_Pokemon IS INSTALLED
						if (GoH_Pokemon_Form:IsVisible()) then
							GoH_Pokemon_Form:Show();
							GoHv5_DeathKnight_Data.config.Menu_IsVisible = "YES";
							GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN = " POKEMON";
						else
							GoH_Pokemon_Form:Hide();
						end
					end

			if GoHv5_DeathKnight_Data.config.Menu_IsVisible == "YES" then
				-- print("OPEN"..GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN);
				GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES";
			else
				-- print("CLOSED"..GoHv5_DeathKnight_Data.config.GOH_FRAME_THAT_IS_OPEN);
				GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO";
			end
	end
end
